package com.bureau.devicefingerprint.di

import com.bureau.devicefingerprint.data.remote.RemoteDataSource
import com.bureau.devicefingerprint.data.remote.RemoteDataSourceImpl
import com.bureau.devicefingerprint.datacollectors.BatteryInfoProvider
import com.bureau.devicefingerprint.datacollectors.BatteryInfoProviderImpl
import com.bureau.devicefingerprint.datacollectors.CameraInfoProvider
import com.bureau.devicefingerprint.datacollectors.CameraInfoProviderImpl
import com.bureau.devicefingerprint.datacollectors.CameraInjectionInfoProvider
import com.bureau.devicefingerprint.datacollectors.CameraInjectionInfoProviderImpl
import com.bureau.devicefingerprint.datacollectors.CpuInfoProvider
import com.bureau.devicefingerprint.datacollectors.CpuInfoProviderImpl
import com.bureau.devicefingerprint.datacollectors.NewRawParametersProvider
import com.bureau.devicefingerprint.datacollectors.NewRawParametersProviderImpl
import com.bureau.devicefingerprint.datacollectors.OsBuildInfoProvider
import com.bureau.devicefingerprint.datacollectors.OsBuildInfoProviderImpl
import com.bureau.devicefingerprint.datacollectors.SettingsDataSource
import com.bureau.devicefingerprint.datacollectors.SettingsDataSourceImpl
import com.bureau.devicefingerprint.datacollectors.SimInfoProvider
import com.bureau.devicefingerprint.datacollectors.SimInfoProviderImpl
import com.bureau.devicefingerprint.datacollectors.SocialEngineeringInfoProvider
import com.bureau.devicefingerprint.datacollectors.SocialEngineeringInfoProviderImpl
import com.bureau.devicefingerprint.datacollectors.WifiInfoProvider
import com.bureau.devicefingerprint.datacollectors.WifiInfoProviderImpl
import dagger.Binds
import dagger.Module

@Module
interface DeviceFingerprintAbstractModule {

    @Binds
    @DeviceFingerprintScope
    fun injectRemoteDataSource(remoteDataSourceImpl: RemoteDataSourceImpl): RemoteDataSource

    @Binds
    @DeviceFingerprintScope
    fun injectBatteryInfoProvider(batteryInfoProviderImpl: BatteryInfoProviderImpl): BatteryInfoProvider

    @Binds
    @DeviceFingerprintScope
    fun injectCameraInfo(cameraInfoProviderImpl: CameraInfoProviderImpl): CameraInfoProvider

    @Binds
    @DeviceFingerprintScope
    fun injectOSBuildInfo(osBuildInfoProviderImpl: OsBuildInfoProviderImpl): OsBuildInfoProvider

    @Binds
    @DeviceFingerprintScope
    fun injectCPUInfo(cpuInfoProviderImpl: CpuInfoProviderImpl): CpuInfoProvider

    @Binds
    @DeviceFingerprintScope
    fun injectSettingsData(settingsDataSourceImpl: SettingsDataSourceImpl): SettingsDataSource

    @Binds
    @DeviceFingerprintScope
    fun injectNewRawParams(newRawParametersProviderImpl: NewRawParametersProviderImpl): NewRawParametersProvider

    @Binds
    @DeviceFingerprintScope
    fun injectSocialEngineeringInfo(socialEngineeringInfoProviderImpl: SocialEngineeringInfoProviderImpl): SocialEngineeringInfoProvider

    @Binds
    @DeviceFingerprintScope
    fun injectWifiInfo(wifiInfoProviderImpl: WifiInfoProviderImpl): WifiInfoProvider

    @Binds
    @DeviceFingerprintScope
    fun injectCameraInjectionProvider(cameraInjectionInfoProviderImpl: CameraInjectionInfoProviderImpl): CameraInjectionInfoProvider

    @Binds
    @DeviceFingerprintScope
    fun injectSimInfoProvider(simInfoProviderImpl: SimInfoProviderImpl): SimInfoProvider
}
