package com.bureau.devicefingerprint.di

import android.app.Application
import com.bureau.base.Environment
import com.bureau.devicefingerprint.BureauAPI
import dagger.BindsInstance
import dagger.Component
import dagger.android.AndroidInjector
import javax.inject.Named

@DeviceFingerprintScope
@Component(modules = [DeviceFingerprintModule::class, DeviceFingerprintAbstractModule::class])
interface DeviceFingerprintComponent : AndroidInjector<BureauAPI> {
    @Component.Factory
    interface Factory {
        fun create(
            @BindsInstance application: Application,
            @BindsInstance environment: Environment,
            @BindsInstance
            @Named(CLIENT_ID)
            credId: String,
            @BindsInstance
            @Named(SESSION_ID)
            sessionId: String,
            @BindsInstance
            @Named(IS_DEV)
            isDev: Boolean,
            @BindsInstance
            @Named(ENABLE_BEHAVIOUR_BIOMETRICS)
            enableBehavioralBiometrics: Boolean
        ): DeviceFingerprintComponent
    }
}
